#!/bin/sh

# 「DNSStubListener=」が含まれる行を削除
resolved_conf_data=$(sed '/^DNSStubListener=.*/d' /etc/systemd/resolved.conf)
echo "${resolved_conf_data}" > /etc/systemd/resolved.conf
# [Resolve]の下に「DNSStubListener=no」を追記
resolved_conf_data=$(sed -e "/^\[Resolve\]$/a DNSStubListener=no" /etc/systemd/resolved.conf)
echo "${resolved_conf_data}" > /etc/systemd/resolved.conf

#systemd-resolved を再起動
sudo systemctl restart systemd-resolved

# 「dns=」が含まれる行を削除
networkmanager_conf_data=$(sed '/^dns=.*/d' /etc/NetworkManager/NetworkManager.conf)
echo "${networkmanager_conf_data}" > /etc/NetworkManager/NetworkManager.conf
# [main]の下に「dns=dnsmasq」を追記
networkmanager_conf_data=$(sed -e "/^\[main\]$/a dns=dnsmasq" /etc/NetworkManager/NetworkManager.conf)
echo "${networkmanager_conf_data}" > /etc/NetworkManager/NetworkManager.conf

#resolve.conf解除
sudo unlink /etc/resolv.conf

#NetworkManagerを再起動
sudo systemctl restart NetworkManager

# 「server=」が含まれる行を削除
default_conf_data=$(sed '/^server=.*/d' /etc/NetworkManager/dnsmasq.d/default.conf) > /dev/null 2>&1
echo "${default_conf_data}" > /etc/NetworkManager/dnsmasq.d/default.conf
# default.confに「server=/ntm200.com/198.18.0.2」を追記
default_conf_data=$(sed -e '$a server=/ntm200.com/198.18.0.2' /etc/NetworkManager/dnsmasq.d/default.conf)
echo "${default_conf_data}" > /etc/NetworkManager/dnsmasq.d/default.conf

#NetworkManagerを再起動
sudo systemctl restart NetworkManager
