var dns = require('dns');
var process = require('child_process');
var os = require('os');

//ver1.3.2 add
//ver1.3.5 edit
var fqdnPath = "/usr/local/videophone/config.dat";
//var fqdnPath = "/usr/local/vnet_auth/config.dat";

var port = 9001;
var io = require('socket.io').listen(port);

var ipAddress = '';

var net = require('net');

var client = new net.Socket();
client.setEncoding('utf8');

var isClientClose = false;

var socketClients = {};
var mykey = "";

var json = "";

var isMyConnection = false;
console.log(" version 1.4.1 ");
console.log((new Date()) + " Server is listening on port " + port);
console.log(getLocalAddress());

function getLocalAddress() {
    var ifacesObj = {}
    ifacesObj.ipv4 = [];
    ifacesObj.ipv6 = [];
    var interfaces = os.networkInterfaces();

    for (var dev in interfaces) {
        interfaces[dev].forEach(function(details){
            if (!details.internal){
                switch(details.family){
                    case "IPv4":
                        ifacesObj.ipv4.push({name:dev, address:details.address});
                    break;
                    case "IPv6":
                        ifacesObj.ipv6.push({name:dev, address:details.address})
                    break;
                }
            }
        });
    }
    return ifacesObj;
};

io.sockets.on('connection', function(socket) {
  console.log((new Date()) + "Accept!!\n");
const ip= socket.handshake.headers['x-forwarded-for'] || socket.conn.remoteAddress.split(":")[3];
   console.log(ip != "127.0.0.1");
   if(ip != "127.0.0.1")
   {
   
   	console.log("isMyConnection:"+isMyConnection);
   	if(!isMyConnection)
	{
		
	 io.to(socket.id).emit('isBrowser',isMyConnection);
	 return;
	}
   }
   else
   {
   		
   	  	isMyConnection = true;
   	  	console.log("isMyConnection:"+isMyConnection);
   }
   
  if (Object.keys(socketClients).length == 1) {
  		socketClients[socket.id] = socket;
  }
  else if (Object.keys(socketClients).length == 0) {
    socketClients[socket.id] = socket;
    mykey = socket.id;
    console.log("mykey:"+mykey);
  } else {
    for (var key in socketClients) {
      delete socketClients[key];
    }
  }

console.log("connection" + Object.keys(socketClients).length);
  for (var key in socketClients) {
      console.log(key);
    }
    
  socket.on('message', function(message) {
    socket.broadcast.emit('message', message);
  });

  socket.on('ipSend', function(data) {
    console.log(socket.request.connection.remoteAddress);
    //socket.broadcast.emit('ipSend',socket.request.connection.remoteAddress);
    socket.broadcast.emit('ipSend',data);
  });

  socket.on('ipRes', function(bl) {
    console.log(bl);
    socket.broadcast.emit('ipRes', bl);
  });
  
  socket.on('close', function() {
	  isMyConnection = false;
	  console.log('mykey'+mykey);
	  
	  for (var key in socketClients) {
	  if(key != mykey)
	  {
      delete socketClients[key];
      }
    }
    console.log("close" + Object.keys(socketClients).length);
    console.log("isMyConnection:"+isMyConnection);
  for (var key in socketClients) {
      console.log(key);
    }
    });

  socket.on('disconnected', function(bl) {
    console.log('hangup:' + socket.id);

    socket.broadcast.emit('disconnected',bl);

    console.log("delete:" + socket.id);
    delete socketClients[socket.id];
    json = "";
  });

  socket.on('ipSet', function(data) {
    console.log('ipSet:'+data);
    ipAddress = data;
  });

  socket.on('ipGet', function(data) {
    console.log('ipGet:'+ipAddress);
    io.to(socket.id).emit('ipGet',ipAddress);
  });

  socket.on('androidServerCheck', function(url) {
    console.log('urlCheck:'+url);

    client.connect(9002, url, function() {
	  console.log('Connected'+client.id);
	  isClientClose = true;
	  client.write('\r\n');
	  //client.broadcast.emit('message','From:Linux2');
	  io.to(socket.id).emit('androidServerCheck',true);
    });

    client.on('data', function(data) {
	  console.log('Received: ' + data + "\n");

	  if(data.indexOf('isRecv') >= 0)
	  {
	  	if(data == "isRecv:OK\n")
	  	{
	  	console.log('ipRes: true');
	  		io.to(socket.id).emit('ipRes',true);
	  	}
	  	else
	  	{
	  	console.log('ipRes: false');
	  		io.to(socket.id).emit('ipRes',false);
	  	}
	  }
	  else if(data.indexOf('hangup') >= 0)
	  {
	  	io.to(socket.id).emit('disconnected',true);
	  }
	  else
	  {
	  	if(data.indexOf('{') >= 0 && data.indexOf('}') >= 0)
	  	{
	  		io.to(socket.id).emit('message',JSON.parse(data));
	  	}
	  	else if(data.indexOf('{') >= 0)
	  	{
	  		json = data.toString().replace("\n","");
	  	}
	  	else if(data.indexOf('}') >= 0)
	  	{
	  		json = json + data.toString().replace("\n","");
	  		 console.log('json: ' + json + "\n");
	  		io.to(socket.id).emit('message',JSON.parse(json));
	  	}
	  	else
	  	{
	  		 json = json + data.toString().replace("\n","");
	  		 console.log('json: ' + json + "\n");
	  	}
	  }
	  //client.destroy(); // kill client after server's response
    });

    client.on('close', function() {
	  console.log('Connection closed'+client.id);
	  isClientClose = false;
	  client = new net.Socket();
    });

    client.on('error', function(err){
      console.log("Error: "+err.message);
      io.to(socket.id).emit('androidServerCheck',false);
      client.destroy();
    });
  });

socket.on('androidSend', function(mes) {
	if(isClientClose)
	{
    	console.log('androidSend:'+mes);
    	client.write(mes + '\r\n');
	}
   //client.end();
  });
    
  socket.on('androidConnect', function(bl) {
    console.log('androidConnect:'+bl);
    socket.broadcast.emit('androidConnect', bl);
  });

  //fqdn
  socket.on('fqdnCheck', function(data) {

    function fqdnEmit(ip) {
      //io.to(socket.id).emit('fqdnCheck','192.168.11.40');
      io.to(socket.id).emit('fqdnCheck',ip);
    }

    //2018/08/11 nomura change
    //setTimeout(function(){checkLookup(data,true,fqdnEmit);},5000);
    //checkLookup(data,false,fqdnEmit);
    checkPing(data,fqdnEmit);
  });
  
  //ver1.3.2 add
  socket.on('myfqdn', function() {
    const fs = require('fs');
    var res = "";
	let text;
	try {
	//ver1.3.3 edit
	  text = fs.readFileSync(fqdnPath,"utf-8");
	} catch (err) {
	  io.to(socket.id).emit('myfqdn',res);
	   return;
	}
	let lines = text.toString().split('\n');
	res = lines[1].replace("\n","");
	res = lines[1].replace("\r","");
	console.log('myfqdn:' + res);
    io.to(socket.id).emit('myfqdn',res);
  });
  
  socket.on('myip', function() {
    var ip = getLocalAddress();
    for(var i = 0; i < ip.ipv4.length; i++)
    {
      if(ip.ipv4[i]["name"] != "tun0")
      {
        io.to(socket.id).emit('myip',ip.ipv4[i]["address"]);
        console.log('myip:' + ip.ipv4[i]["address"]);
        return;
      }
    }
  });
});

var blLookup = false;

function checkLookup(data,blTimeOut,callback) {
  console.log('fqdnCheck:' + data);
  console.log('blTimeOut:' + blTimeOut);

  if(blTimeOut == false)
  {
    dns.lookup(data, function onLookup(err, address, family) {
      blLookup = true;
      if (err) {
        console.log('ip:null');
        callback(null);
      }
      else
      {
        console.log('ip:', address);
        callback(address);
      }
    });
  }
  else
  {
    if(blLookup)
    {
      blLookup = false;
    }
    else
    {
      callback(null);
    }
  }
}

//2018/08/11 nomura add
function checkPing(data,callback)
{
  console.log('fqdnCheck:' + data);

  //var exec = process.exec('ping -c 1 -n ' + data,(error,stdout,stderr) => {
  var exec = process.exec('nslookup ' + data,(error,stdout,stderr) => {
    if(error)
    {
     
      //ver1.3.0 add
      var start = stdout.indexOf('Address: ', 0);

      if(start == -1)
      {
      	 console.log('error:' + stderr);
      	 callback(null);
      }
      else
      {
	      start = start + 9;
	      var end = stdout.indexOf('**', start);

	      console.log('start:' + start);
	      console.log('end:' + end);

	      var address = stdout.slice(start,end);

	      console.log('address:' + address);
	      
	      callback(address);
      }
    }
    else
    {
      console.log('stdout:' + stdout);

      var start = stdout.indexOf('Address: ', 0);
      
      start = start + 9;
      var end = stdout.indexOf(';;', start);

      console.log('start:' + start);
      console.log('end:' + end);

      var address = stdout.slice(start,end);

      console.log('address:' + address);

      callback(address);
    }
  });
}
